#!/usr/bin/python3
from __future__ import print_function
# -*- coding: utf-8 -*-
#################################### copier depuis python2
_FonctionDuProgramme="travail avec les images par sf"

_Version="3.0.1"
__version__=_Version

#3.0.1 _FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
#1.0.1 calcul des Ax,BX,AY,BY dans INIT_minmaxToMINMAX pour rToR
"""
print(_FonctionDuProgramme)
print("_Version",_Version)

"""

##################### debug
import sys,re

_debug_Titres=True #
_debug_Titres=False

_debug_Log=True #
_debug_Log=False

_debug_all=True #
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug_Log=True

_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)
		print(*args,file=_Log)
#def Dprint(ligne):
def Dprint(*args, **kwargs):
	if _debug_all==True:
		print(*args, **kwargs)
		print('--------------------------')

def Eprint(*args, **kwargs):
	Dprint(*args, **kwargs)
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

from random import randint
import time




from sfml import sf

class CImage(object):

	def __init__(self,_NomFich=None):
		self.image=None
		self.donnees=None
		self.h,self.w=None,None
		self.data=None

		if _NomFich != None:
			self._NomFich=_NomFich
			self.LitUnFichier(self._NomFich)
		pass


	def INIT_minmax(self,Valeurs=[[-3000,3000],[-3000,3000],[-3000,3000]]):
		Tprint("CImage.INIT_minmax")
		self._xmin,self._xmax = Valeurs[0][0],Valeurs[0][1]
		self._ymin,self._ymax = Valeurs[1][0],Valeurs[1][1]
		self._zmin,self._zmax = Valeurs[2][0],Valeurs[2][1]

	def INIT_minmaxToMINMAX(self):
		xmin,xmax,ymin,ymax=self._xmin,self._xmax,self._ymin,self._ymax
		Xmin,Xmax,Ymin,Ymax=self._Xmin,self._Xmax,self._Ymin,self._Ymax
		self.AX , self.BX = (Xmax-Xmin) / (xmax-xmin) , 0.5 + Xmin -xmin  /(xmax-xmin)*(Xmax-Xmin)
		self.AY , self.BY = (Ymax-Ymin) / (ymax-ymin) , 0.5 + Ymin -ymin  /(ymax-ymin)*(Ymax-Ymin)

	#def LitUneImage(self,_NomFich):
	def LitUnFichier(self,_NomFich=None):
		''' on obtient self.image '''
		if _NomFich != None:
			self._NomFich=_NomFich
		self.image= sf.Image.from_file(self._NomFich)
		self.AnalyseImage()

	def AnalyseImage(self):
		''' on obtient self.donnees[L][C] dans [0,255]*3 '''
		self.height,self.width=self.image.height,self.image.width
		self.h,self.w=self.height,self.width

		data=self.image.pixels.data

		h,w=self.h,self.w
		self.donnees=[ [ [int(data[4*(l*w+c+0)]),int(data[4*(l*w+c)+1]),int(data[4*(l*w+c)+2]),int(data[4*(l*w+c)+3])] for c in range(w)] for l in range(h)]
		self.donnees=[ [self.col(c,l) for c in range(w)] for l in range(h)]


		self.data=data
		self.dims=(self.height,self.width)

		#print(self.donnees)
		R=[255,0,0,255]
		V=[0,255,0,255]
		B=[0,0,255,255]
		"""background=pixels.data
		print(type(background))
		print((background))
		print(dir(background))
		print(len(background))
		"""

		#self._xmin,self._xmax,self._ymin,self._ymax=-3000,3000,-3000,3000
		#self._zmin,self._zmax=-3000,3000

		self._Xmin,self._Xmax=0,self.w-1
		self._Ymin,self._Ymax=0,self.h-1

		#self.INIT_minmaxToMINMAX()

		#X=int(0.5+ (x-xmin)/(xmax-xmin)*(Xmax-Xmin)+Xmin )
		#Y=int(0.5 -(y-ymin)/(ymax-ymin)*(Ymax-Ymin)+Ymax )


	def CreeUneImageBlanche(self,lignes=20,colonnes=50, initialise_minmax=False):
		self.CreeUneImage(lignes,colonnes,sf.Color(255,255,255,255),initialise_minmax)

	def CreeUneImage(self,lignes=20,colonnes=50,couleur=sf.Color(0,0,0,255), initialise_minmax=False):
		self.image= sf.Image.create(colonnes,lignes,couleur )#.BLACK)
		if initialise_minmax==True:
			self.INIT_minmax()
		self.AnalyseImage()

	def col(self,i,j):
		p=self.image[i,j]
		r,g,b,a=p.r,p.g,p.b,p.a
		return [r,g,b,a]

	def AfficheUneImage(self):
		"""
		texture = sf.Texture.from_image(self.image)
		window = sf.RenderWindow(sf.VideoMode(texture.width,texture.height), self._NomFich)
		sprite = sf.Sprite(texture)

		while window.is_open:
			# process events
			for event in window.events:
				# close window: exit
				if type(event) is sf.CloseEvent:
					window.close()

			window.clear() # clear screen

			window.draw(sprite) # draw the sprite
			window.display() # update the window
			'''


			i,j=randint(0,self.h),randint(0,self.w)
			color=self.image[i,j]
			color.a=randint(0,255)
			self.image[i,j]=color

			texture.display()

			window.draw(StormBlink()) # draw the sprite
			'''
		"""
		self.image.show()

	def rToR(self,x,y):
		'''
		xmin,xmax,ymin,ymax=self._xmin,self._xmax,self._ymin,self._ymax
		Xmin,Xmax,Ymin,Ymax=self._Xmin,self._Xmax,self._Ymin,self._Ymax
		X=int(0.5+ (x-xmin)/(xmax-xmin)*(Xmax-Xmin)+Xmin )
		Y=int(0.5 -(y-ymin)/(ymax-ymin)*(Ymax-Ymin)+Ymax )
		'''
		X , Y = int ( self.AX * x + self.BX ) , int ( self.AY * y + self.BY )
		return (X,Y)

	def Valide(self,X,Y):
		if (X>=self._Xmin)and(X<self._Xmax)and(Y>=self._Ymin)and(Y<self._Ymax):
			return True
		else:
			return False

	def PointSurImage(self,x,y,col=0):
		Y,X=self.rToR(x,y)
		Dprint("Y=",Y,",X=",X,",couleur=",couleur(col))
		if self.Valide(X,Y):
			self.image[Y,X]=couleur(col)

	def zzzLigne(self,x1,y1,x2,y2,col=0):
		#Y1,X1=self.rToR(x1,y1)
		#Y2,X2=self.rToR(x2,y2)
		#if self.Valide(X1,Y1) and self.Valide(X2,Y2):
		s=1+int(((x1-x2)**2+(y1-y2)**2)**0.5)
		for i in range(s):
			x=x1+i/s*(x2-x1)
			y=y1+i/s*(y2-y1)
			self.PointSurImage(x,y,col)




	def Enregistre(self,fichier="/tmp/c.png"):
		self.image.to_file(fichier)


def couleur(i):
	#col=[ sf.Color(1.0,0.0,0.0),sf.Color(0.0,1.0,0.0),sf.Color(0.0,0.0,1.0),sf.Color(1.0,1.0,0.0),sf.Color(0.0,1.0,1.0),sf.Color(1.0,0.0,1.0),sf.Color(0.5,1.0,0.2)]
	col=[ sf.Color(255,255,255),sf.Color(255,0,0),sf.Color(0,255,0),sf.Color(0,0,255),sf.Color(255,255,0),sf.Color(0,255,255),sf.Color(255,0,255),sf.Color(128,255,51)]
	return col[i % len(col)]



global main
def CMAIN():
	pass

if __name__ == "__main__":

	#a=CImage("/tmp/b.png")
	a=CImage()
	a.CreeUneImage(100,100)

	for j in range(a.w // 20):
		a.image[j,10]=sf.Color(randint(0,255),randint(0,255),randint(0,255),255)

	#a.Ligne(1,1,50,50)
	a.AfficheUneImage()
	a.image.to_file("/tmp/a.png")








'''
# # # # # # # # # # # # # # #  texture
<class 'sfml.graphics.Texture'>
file:///usr/share/doc/python-sfml-doc/html/api/graphics.html#texture
Texture(size=(20, 6), smooth=False, repeated=False)
['NORMALIZED', 'PIXELS',
'__class__', '__copy__', '__deepcopy__', '__delattr__', '__dir__',
'__doc__', '__eq__', '__format__', '__ge__',
'__getattribute__', '__gt__', '__hash__', '__init__',
'__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__',
'__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__',

'bind', 'copy', 'copy_to_image', 'create', 'draw', 'from_file',
'from_image', 'from_memory', 'from_size', 'get_maximum_size',
'height', 'repeated', 'size', 'smooth', 'to_image', 'update',
'update_from_image', 'update_from_pixels', 'update_from_window', 'width']
'''


'''
# # # # # # # # # # # # # # #  sprite
<class 'sfml.graphics.Sprite'>
file:///usr/share/doc/python-sfml-doc/html/api/graphics.html#sprite
Sprite(texture=140200447490888, texture_rectangle=(0, 0, 20, 6), color=(R=255, G=255, B=255, A=255))
['__class__', '__delattr__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__',
'__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__',
 '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__',
  '__str__', '__subclasshook__',

   'color', 'draw', 'global_bounds', 'inverse_transform', 'local_bounds', 'move',
   'origin', 'position', 'ratio', 'rotate', 'rotation', 'scale', 'texture',
   'texture_rectangle', 'transform', 'transformable']
'''

'''
# # # # # # # # # # # # # # #  image
<class 'sfml.graphics.Image'>
file:///usr/share/doc/python-sfml-doc/html/api/graphics.html#image
Image(size=(20, 6))
['__class__', '__copy__', '__deepcopy__', '__delattr__', '__delitem__', '__dir__', '__doc__',
 '__eq__', '__format__', '__ge__', '__getattribute__', '__getitem__', '__gt__', '__hash__',
  '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__',
  '__repr__', '__setattr__', '__setitem__', '__sizeof__', '__str__', '__subclasshook__',

   'blit', 'create', 'create_mask_from_color', 'flip_horizontally', 'flip_vertically',
   'from_file', 'from_memory', 'from_pixels', 'from_size', 'height', 'pixels', 'show',
   'size', 'to_file', 'width']

# # # # # # image.pixels
<class 'sfml.window.Pixels'>
Pixels(width=20, height=6)
['__class__', '__delattr__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__',
 '__getattribute__', '__getitem__', '__gt__', '__hash__', '__init__', '__le__', '__lt__',
 '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__',
  '__str__', '__subclasshook__',

     'data', 'height', 'width']

# # # # # # image.pixels.data
<class 'bytes'>
b'\x40\x40\x40\x40\x40\x40\x40\x40
b'RVBARVBA
'''


