#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="differentes fonctions utilisables"
#print(_FonctionDuProgramme)
_Version="3.1.2"
__version__=_Version
"""
312 réécriture de HexInt
311 ajout de SansAccent
310 EstUnTableauDe
306 nestpaszero
30.5 sontdes ; changement de Dprint
3.0.4 estun tableau, estunnombre
1.0.3 : IntHex
1.0.1 md5 : renvoir time .time() si erreur

dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)


"""
#print("version:"+_Version)
import re
import os
import math
##################### debug
import sys
_debug=True #
_debug=False

_debug_Titres=True #
_debug_Titres=False

_debug_all=True #
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug=True #

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print(sys.argv[0],*args, **kwargs)
		print(sys.argv[0],*args,file=_Log)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""
class br_CDict(dict):
	def __init__(self,retour=""):
		self._retour=retour
	def __missing__(self, key):
		return self._retour
class CMachin(object):
	""" CLASSE CMachin(object) """
	def __init__(self,_rep=''):
		pass#self._repertoire=_rep

'''
print ( os.path.split('/tmp/bb.jpg') )
('/tmp', 'bb.jpg')
print ( os.path.splitext('/tmp/bb.jpg') )
('/tmp/bb', '.jpg')


print ( os.path.split('/tmp/bb/') )
('/tmp/bb', '')
print ( os.path.splitext('/tmp/bb/') )
('/tmp/bb/', '')



print ( o.split('/tmp/bb') )
('/tmp', 'bb')
print ( os.path.splitext('/tmp/bb') )
('/tmp/bb', '')

'''
DicoFonctions=br_CDICO()




############################ chaines, tableaux de chaines
#3.1.1
import unicodedata
def SansAccent(entree):
	'''SansAccent(chaine|tuple|tableau) : enlève les accents
	'''
	if EstUneChaine(entree):
		s=entree
		return ''.join(c.lower() for c in unicodedata.normalize('NFD', s) if unicodedata.category(c) != 'Mn')
	if EstUnTableau(entree):
		tabl=[]
		for entree2 in entree:
			tabl.append(SansAccent(entree2))
		return tabl
	if EstUnTuple(entree):
		tupl=[]
		for entree2 in entree:
			tupl.append(SansAccent(entree2))
		return tuple(tupl)
DicoFonctions["SansAccent"]=SansAccent.__doc__


def	TableauToString(tablo,sep=""):
	''' TableauToString(tablo,sep="") : tableau de string devient une string
	retourne str||None
	'''
	texte=""
	for t in tablo:
		if isinstance(t,str):
			texte+=t+sep
		else:
			return None
	return texte
DicoFonctions["TableauToString"]=TableauToString.__doc__


def EstUneChaine(obj,strict=True):
	""" Verifie si un objet est une chaine de caractères(str)"""
	return EstUn(obj,str,strict)
def ZZEstUnechaine(obj,strict=True):
	return EstUneChaine(obj,strict)















#1.0.5 def Md5(fname):	''' str Md5('nom fich') '''
def Md5(fname,Impossible="time"):
	''' Md5('nom fich' , Impossible="time" )
	retourn str||time()||\"\" '''
	import hashlib
	hash_md5 = hashlib.md5()
	try:
		with open(fname, "rb") as f:
			for chunk in iter(lambda: f.read(4096), b""):
				hash_md5.update(chunk)
		return hash_md5.hexdigest()
	except:
		if Impossible=="time":
			from time import time
			return str(time())
		else:
			return ""
DicoFonctions["Md5"]=Md5.__doc__




def HexsInt(hexa,N=1):
	""" transforme des blocs d'hexadecimaux de longueur N en entiers """
	res=[]
	for i in range(0,len(hexa),N):
		hexaN=hexa[i:i+N]
		"""
		nb=0
		for j in range(N):
			nb=nb*16+HexInt(hexaN[j])
		"""
		nb=HexInt(hexaN)
		res+=[nb]
	return res
DicoFonctions["HexInt"]=HexsInt.__doc__

def IntHex(entier,N=-1,res=""):
	""" transforme un entier en hexadecimal de longueur N"""

	if int(entier)==entier and entier>=0 and entier<=15:
		if entier>=0 and entier<=9:
			res=res+str(entier)
		else:
			res=res+chr(55+entier)
		entier=0
		if N!=-1:
			res="0"*(int((N-1)/N)*N-1)

	if entier!=0:
		M=int(math.log10(entier)/math.log10(16))
		if N!=-1:
			res="0"*(int((N+M-1)/N)*N-(M+1))
		aM=int(entier/16**M)
		res=res+IntHex(aM)
		res=IntHex(entier-aM*16**M,-1,res)

	return res
DicoFonctions["IntHex"]=IntHex.__doc__

def HexInt(hexa):
	""" transforme une chaine hexadecimal de longueur N en entier  HexInt("100")=256 ; HexInt(100)=256 ; HexInt("0x100")=256;HexInt(0x100)=256 SINON None"""
	if EstUneChaine(hexa):
		if hexa[0:2]=="0x":
			return HexInt(hexa[2:])
		else:
			if len(re.sub("[0-9a-fA-F]","",hexa))!=0:return None
			else:
				res=""
				try:
					N=len(hexa)
				except:
					hexa=[hexa]
					N=len(hexa)
				for i in range(N):
					if N==1:
						lettre=hexa[i].lower()
						if ord(lettre)<48+10:#0-9
							nb=ord(lettre)-48
						else:#a-f
							nb=ord(lettre)-87
						res=nb
					else:
						nb=0
						for j in range(N):
							nb=nb*16+HexInt(hexa[j])
						res=nb
				return res
	else:
		if EstUnNombre(hexa):
			return HexInt(str(hexa))
		else:return None
DicoFonctions["HexInt"]=HexInt.__doc__



def ZHexInt(hexa):#311
	""" transforme une chaine hexadecimal de longueur N en entier  HexInt("100")=256 ; HexInt(100)=100 SINON None"""
	if EstUneChaine(hexa):
		
		res=""
		try:
			N=len(hexa)
		except:
			hexa=[hexa]
			N=len(hexa)
		for i in range(N):
			if N==1:
				if ord(hexa[i])<48+10:
					nb=ord(hexa[i])-48
				else:
					nb=ord(hexa[i])-87
				res=nb
			else:
				nb=0
				for j in range(N):
					nb=nb*16+HexInt(hexa[j])
				res=nb
		return res
	else:
		if EstUnNombre(hexa):
			return hexa
		else:return None
DicoFonctions["HexInt"]=HexInt.__doc__

'''
def EstUnEntier(obj):
	""" Verifie si un objet est un entier(int)"""
	if isinstance(obj,int):
		return True
	else:
		return False

def EstUnReel(obj):
	""" Verifie si un objet est un reel(float)"""
	if isinstance(obj,float):
		return True
	else:
		return False

def EstUnTuple():
	""" Verifie si un objet est un tableau de type tuple(tuple)"""
	if isinstance(obj,tuple):
		return True
	else:
		return False
'''
def EstUn(obj,typeuh,strict=True):
	""" EstUn(obj,typeuh,strict=True) : Verifie si un objet est un (typeuh)"""
	if strict==True:
		if isinstance(obj,typeuh):
			return True
		else:
			return False
	else:
		if isinstance(obj,str):
			if chr(typeuh(obj))==obj:
				return True
			else:
				return False
		else:
			return False
DicoFonctions["EstUn"]=EstUn.__doc__

def EstUnEntier(obj,strict=True):
	""" Verifie si un objet est un entier(int)"""
	#print(float(int(obj)),obj)
	return EstUn(obj,int,strict)# or ( EstUnReel(obj,strict) and float(int(obj))==float(obj))

def EstUnReel(obj,strict=True):
	""" Verifie si un objet est un reel(float)"""
	return EstUn(obj,float,strict)

def EstUnTuple(obj,strict=True):
	""" Verifie si un objet est un tableau de type tuple(tuple)"""
	return EstUn(obj,tuple,strict)

def EstUnArray(obj,strict=True):
	""" Verifie si un objet est un tableau []"""
	return EstUn(obj,list,strict)

def EstUnTableau(obj,strict=True):#3.0.4
	""" Verifie si un objet est un tableau [] ou un tableau de type tuple(tuple)"""
	return EstUnArray(obj,strict) or EstUnTuple(obj,strict)


''' fonctionne pas ??
def EstUnTableauDe(obj,strict=True,TypeDuTableau=str):#310
	_res=False
	if EstUnTableau(obj,strict=strict):
		_res=True
		print("rrr")
		for contenu in obj:
			if not EstUn(contenu,TypeDuTableau,strict):
				_res=False
	return _res
'''

def EstUnNombre(obj,strict=True):#3.0.4
	""" Verifie si un objet est un entier(int) ou un reel(float)"""
	return EstUnEntier(obj,strict) or EstUnReel(obj,strict)

def EstZero(obj,strict=True):
	if EstUnNombre(obj,strict):#3.0.4
		if EstUnEntier(obj,strict):
			if obj==0:
				return True
			else:
				return False
		if EstUnReel(obj,strict):
			if obj==0.0:
				return True
			else:
				return False
	return False


def SontDes(objs,typeuh,strict=True):
	""" SontDes(objS,typeuh,strict=True) : Verifie si un TABLEAU D'objet sont des (typeuh)"""
	if EstUnTableau(objs):
		NbDeNombres=len(objs)-len([1 for o in objs if EstUn(o,typeuh,strict) ])
		if NbDeNombres==0:
			return True
		else:
			return False
	elif EstUn(i,typeuh,strict):
		return True
	else:
		return False
DicoFonctions["SontDes"]=SontDes.__doc__



def SontDesNombres(obj,strict=True):#3.0.4
	""" Verifie si un objet est une liste de nombres : retourne True ou False ( si au moins un n'est pas un nombre"""
	if EstUnTableau(obj):
		NbDeNombres=len(obj)-len([1 for o in obj if EstUnNombre(o,strict) ])
		if NbDeNombres==0:
			return True
		else:
			return False
	elif EstUnNombre(i,strict):
		return True
	else:
		return False















def Puissance10(n):
	Nb=None
	#print("===",n)
	if EstUnEntier(n):
		#print(type(n))
		if n==0:
			Nb=1
		elif n>0:
			#print("***",n)
			Nb=10*Puissance10(n-1)
		else:# n<0:
			Nb=Puissance10(n+1)/10
		return Nb
	else:
		return 0*10.0**n

def Decimal(nombre,arrondi=1):
	if EstUnEntier(arrondi):
		if arrondi<0:
			return int(nombre*Puissance10(-arrondi))/Puissance10(-arrondi)
		else:
			return int(nombre/Puissance10(arrondi))*Puissance10(arrondi)
	else:
		return int(nombre*Puissance10(-arrondi))*Puissance10(arrondi)











import csv
def DictToClefs(dico):
	return [clef for clef in dico.keys()]
def TabloDeDictToClefs(tablo):
	dico=dict()
	for tmp in tablo:
		dico.update(tmp)
	return DictToClefs(dico)
def ToCsv(tablo,fichier='/tmp/CXml.csv',*Clefs,ID=True):
	"""ToCsv(tablo,fichier='/tmp/CXml.csv',*Clefs) : nécessite tablo=[dico1,dico2...] avec dico[cle]=valeur\
	par exemple ToCsv(TabloDeDict,"/tmp/a.csv",TabloDeDictToClefs(TabloDeDict)]
	"""
	Champs=[]
	if ID==True:
		Champs=["id"]
	if len(Clefs)!=0:
		Champs=Champs+list(Clefs)[0]
	#print(Champs)

	with open(fichier, 'w', newline='') as csvfile:
		fieldnames = Champs
		writer = csv.DictWriter(csvfile, fieldnames=fieldnames,delimiter="#")
		writer.writeheader()
		for no,dico in enumerate(tablo):
			ID=dict()
			ID["id"]=str(no)
			ID.update(dico)
			writer.writerow(ID)
		"""
		writer.writerow({'first_name': 'Baked', 'last_name': 'Beans'})
		writer.writerow({'first_name': 'Lovely', 'last_name': 'Spam'})
		writer.writerow({'first_name': 'Wonderful', 'last_name': 'Spam'})
		"""
	#return res





def SpheriquesToCartesiennes(rr,ttheta=None,pphi=None):# 0 à inf, 0 à pi/2,0 à pi
	"""(A)(r,theta,phi)=>x,y,z \
	OU (B)[r,theta,phi],,=>[x,y,z],None,None\
	OU (C)[[r0,theta0,phi0],[r1,theta1,phi1]...],, => [[x0,y0,z0],[x1,y1,z1]...],None,None \
	OU (D)[r0,r1...],[theta0,theta1...],[phi0,phi1...] => [x0,x1...],[y0,y1...],[z0,z1...]"""

	from math import cos,sin,pi,acos as arccos,fabs

	if (EstUnNombre(rr) and EstUnNombre(ttheta) and EstUnNombre(pphi)) or ( (EstUnTableau(rr) and not EstUnTableau(ttheta) and not EstUnTableau(pphi)) and (EstUnNombre(rr[0]) and EstUnNombre(rr[1]) and EstUnNombre(rr[2]))):#(A) ou (B)
		if EstUnTableau(rr):
			r,theta,phi=rr[0],rr[1],rr[2]
			x=r*sin(theta)*cos(phi)
			y=r*sin(theta)*sin(phi)
			z=r*cos(theta)
			return [x,y,z]
		else:
			r,theta,phi=rr,ttheta,pphi
			x=r*sin(theta)*cos(phi)
			y=r*sin(theta)*sin(phi)
			z=r*cos(theta)
			return 	x,y,z

	elif EstUnTableau(rr) and not EstUnTableau(ttheta) and not EstUnTableau(pphi):#(C)[[r,theta,phi],[r,theta,phi]...],, => [[x,y,z],[x,y,z]...],None,None \
		x,y,z=[],None,None

		for rrr in rr:#rrr==[r,theta,phi]
			x.append([(SpheriquesToCartesiennes(rrr[0],rrr[1],rrr[2]))])
		return x,y,z

	elif EstUnTableau(rr) and EstUnTableau(ttheta) and EstUnTableau(pphi):#(D)
		x,y,z=[],[],[]
		for i in range(len(rr)):
			XX,YY,ZZ=SpheriquesToCartesiennes(rr[i],ttheta[i],pphi[i])
			x.append(XX)
			y.append(YY)
			z.append(ZZ)
		return x,y,z








global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	print(HexsInt('1ab',1))
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	print('= '*20)
	print('import CFonctions3')
	for a in DicoFonctions:
		print('\nfrom CFonctions3 import '+a)
		print("  "+DicoFonctions[a])


	sys.exit()




