#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function

import sys
import re
_FonctionDuProgramme=re.sub(".*/","",sys.argv[0])
_FonctionDuProgramme+="\n\
CPolynome\
CMaths_RK4\
\
"

dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)

#print(_FonctionDuProgramme)
_Version="1.0"
__version__="1.0"
#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"


import os

##################### debug
_debug_all=True # 
_debug_all=False

_debug_Titres=True #
_debug_Titres=False

_debug=True #
_debug=False

if _debug_all==True:
	_debug_Titres=True
	_debug=True

_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print('==========================Dprint')
		print(sys.argv[0],*args, **kwargs)					
		print(sys.argv[0],*args,file=_Log)
		print('  =  =  =  =  =  =  =  =')
# # # # # # # # # # # # # # # # # # # debug
class br_CDict(dict):
	def __init__(self,retour=""):
		self._retour=retour
	def __missing__(self, key):
		return self._retour
class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CProjetDePo(object):
	def __init__(self,_rep=''):
		self._repertoire=_rep


DicoFonctions=br_CDICO()
DicoClasses=br_CDICO()


from math import *
from CFonctions3 import *#EstUnArray,EstUnNombre
import os	

def paritee(a):
	""" retourne la paritee de a sans verification"""
	try:
		b=int(a)
		if 2*int(b/2)==a:
			return "pair"
		elif 2*int((b+1)/2)==a+1:
			return "impair"
		else: 
			return None	
	except:
		return None
			
DicoFonctions["paritee"]=paritee.__doc__	
def signe(a):
	""" retourne le signe de a sans verification"""
	return sgn(a)
DicoFonctions["signe"]=signe.__doc__	
def sgn(a):	
	""" retourne le signe de a sans verification"""
	if EstUnNombre(a):
		if a>0:
			return 1
		elif a==0:
			return 0
		else:
			return -1		
	else:
		return None	
DicoFonctions["sgn"]=sgn.__doc__

def factorielle(n):
	""" retourne la factorielle de n sans verification"""
	try:
		if n==1 or n==0:
			return 1
		else:
			return n*factorielle(n-1)	
	except:
		return None
DicoFonctions["factorielle"]=factorielle.__doc__		
		
		
import CMaths_Polynomes		

from CMaths_Polynomes import CPolynome
if __name__ == "__main__":
	
	print("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	
	print('import CMaths')
	for a in DicoFonctions:
		print('from CMaths import '+a)
		print("  "+DicoFonctions[a])
	for a in DicoClasses:
		print('from CMaths import '+a)
		print("  "+DicoClasses[a])
		
	
	A=CPolynome("2x^2")

try:
	_Log.close()
except:
	pass	



